/* ###################################################################
**     Filename    : main.c
**     Project     : example_6
**     Processor   : MC9S08SE8CWL
**     Version     : Driver 01.12
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2023-10-27, 15:20, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.12
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "PTC.h"
#include "PTB.h"
#include "COPFree.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
#include "LCD_2x16.h"
#include "I2C_Software.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define TEA5767_W 0xC0
#define PORTC_D3  PTCD_PTCD3
#define PORTC_D2  PTCD_PTCD2

float fm=98.9;
unsigned int freq=989; 

void print_freq(unsigned int frec ) { 
	
	uint8_t i=0;
	signed char ch[5];
	
	      ch[0] = frec / 1000;
		  ch[1] = (frec / 100)%10;
		  ch[2] = (frec / 10)%10;
		  ch[3] = -2; //(.)point character = 46;
		  ch[4] = frec %10;
		  if(frec<1000)ch[0]=-16;// space. 
		  
		  for(i=0; i<=4; i++) {  
		 	        Lcd_One_Chr(2, 4+i, ch[i]+48);
		 	     } 
		  Cpu_Delay100US(50);  
}
	  

void Tea5767_setFrequency(double frequency)
{
  unsigned char frequencyH=0;
  unsigned char frequencyL=0;
  unsigned int frequencyB;

  frequencyB=4*(frequency*1000000+225000)/32768;
  frequencyH=frequencyB>>8;
  frequencyL=frequencyB&0XFF;

  TWI_Start();
  TWI_Write(TEA5767_W);
  TWI_Write(frequencyH);
  TWI_Write(frequencyL);
  TWI_Write(0xB0);
  TWI_Write(0x10);
  TWI_Write(0x00);
  TWI_Stop();
  Cpu_Delay100US(50);
}	
void main(void)
{
  /* Write your local variable definition here */
	uint8_t  e0=0, e1=0;
  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/
  
  /* Write your code here */
  /* For example: for(;;) { } */
  
  COPFree_Init();
  PTC_Init();
  PTB_Init();
  Lcd_Init();
  Lcd_Out(1, 4, "FM_RADIO");
  Lcd_Out(2, 10, "MHz");
  Tea5767_setFrequency(fm);  
  print_freq(freq);
  
  for(;;) { 
	  
	  if(PORTC_D2 ==0){
		 Cpu_Delay100US(30);
	  	 if(PORTC_D2==0)e0=1, Cpu_Delay100US(30); 
	  }
	 if((PORTC_D2==1)&& (e0==1)) { 
	  	  e0=0; freq++; fm=fm+0.1; 
	  	  if(fm>108.0)fm=88.0;
	  	  if(freq>1080)freq=880;
	  	  Tea5767_setFrequency(fm);
	  	  print_freq(freq);
	  	}
	  	 	  
	  	 if(PORTC_D3==0) {
	  	   Cpu_Delay100US(30);  
	  	   if(PORTC_D3==0)e1 =1, Cpu_Delay100US(30); 
	  	 }
  	    if((PORTC_D3==1)&& (e1==1)) { 
	  	    e1=0; freq--; fm=fm-0.1;
	  	 	if(fm<88.0)fm=108.0;
	  	 	if(freq<880)freq=1080;
	  	 	Tea5767_setFrequency(fm);
	  	 	print_freq(freq);
	  	 }	  
	  	 		  
  }

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
